package lectura_ficheros;

/*
 * Copyright (c) 1995 - 2008 Sun Microsystems, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of Sun Microsystems nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */ 

import java.io.*;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


public class Explorador extends JPanel implements ActionListener {
	private static final long serialVersionUID = 1L;
	
	
    JButton openButton, readButton;
    JTextFieldTabulador separ;
    JTextField num_lin_oe, num_lin_uni, num_lin_fec, num_lin_datos, log; 
    
    JFileChooser fc;
    File file;
    
    //TODO inicializar aqui??
    ContenidoFichero contenido = new ContenidoFichero();


    public Explorador() {
        super(new BorderLayout());

        //crear campos JTextFields para la entrada de datos
        separ = new JTextFieldTabulador(1);
        //Desabilitamos la funcin del tabulador como tecla especial
        separ.setFocusTraversalKeysEnabled(false);     

        num_lin_oe = new JTextField(3);
        num_lin_uni = new JTextField(3);
        num_lin_fec = new JTextField(3);
        num_lin_datos = new JTextField(3);
        //creamos el JTextField para el archivo seleccionado
        log = new JTextField(30);
        
        //crear etiquetas
        JLabel lsepar, loe, luni, lfec, ldatos;
        lsepar = new JLabel("Separador");
        loe = new JLabel("Linea Obj. Est");
        luni = new JLabel("Linea Uds");
        lfec = new JLabel("Linea Fechas");
        ldatos = new JLabel("Linea Datos");
        
        //Ponemos en un panel las etiquetas y los JTextFields
        JPanel textAreasPanel = new JPanel(); //use FlowLayout
        textAreasPanel.add(lsepar);			textAreasPanel.add(separ);
        textAreasPanel.add(loe);			textAreasPanel.add(num_lin_oe);
        textAreasPanel.add(luni);	        textAreasPanel.add(num_lin_uni);
        textAreasPanel.add(lfec);	        textAreasPanel.add(num_lin_fec);
        textAreasPanel.add(ldatos);	        textAreasPanel.add(num_lin_datos);

        //creamos el boton para abrir el explorador y buscar archivos
        openButton = new JButton("Seleccionar Archivo...");
        openButton.addActionListener(this);
        //y lo anhadimos a un panel
        JPanel buttonPanel = new JPanel();
        buttonPanel.add(openButton);
        
        //creamos el boton para leer el archivo seleccionado
        readButton = new JButton("Leer Archivo");
        readButton.addActionListener(this);
        //y lo anhadimos a un panel junto con "log"
        JPanel readPanel = new JPanel(); 
        readPanel.add(log);
        readPanel.add(readButton);
        
        //creamos un panel que lo incluira todo
        JPanel todo = new JPanel();
        //anhadimos los paneles creados
        todo.add(buttonPanel);
        todo.add(textAreasPanel);
        todo.add(readPanel);
        
        //creamos el panel con todos los paneles
        add(todo);
        
        //TODO poner al final
        //Creamos un explorador
        fc = new JFileChooser();
        
    }

    public void actionPerformed(ActionEvent e) {

    	//TODO hacer que los botones se pulsen con el intro tambien
        //Acciones del boton openButton
        if (e.getSource() == openButton) {
            int returnVal = fc.showOpenDialog(Explorador.this);

            if (returnVal == JFileChooser.APPROVE_OPTION) {
                file = fc.getSelectedFile();
                //This is where a real application would open the file.
                log.setText(file.getAbsolutePath());
            } else {
            	log.setText("Open command cancelled by user.");
            }

        //Acciones del boton readButton
        } else if (e.getSource() == readButton) {
            char carsep = separ.getText().charAt(0);
            FicheroDatos fd = new FicheroDatos(file, carsep);
            try {
            	//TODO mostrar mensaje de error cuando no se dejen campos en blanco
				contenido = fd.leerFicheroDatos(log.getText(), carsep, 
						Integer.parseInt(num_lin_oe.getText()), Integer.parseInt(num_lin_uni.getText()), 
						Integer.parseInt(num_lin_fec.getText()), Integer.parseInt(num_lin_datos.getText()));
				
				//PanelOpciones po= new PanelOpciones("Modificacion de datos", obj_estudio,unids,data,data);
				//con "po" se refinan los metadatos obtenidos manualmente
				//////////////////////////////////////////////////
				///////////////  AQUIIII  ////////////////////////
				//////////////////////////////////////////////////
				//TODO los cambios hechos por po no se ven reflejados al hacer setMetadatos!!
				PanelOpciones po= new PanelOpciones("Modificacion de datos", contenido.getMetadatos());
				//TODO manejar que pasa si se elimina una columna de datos
				contenido.setMetadatos(po.getMetadatos());	
				System.out.println("vamos a ver...");
				System.out.println(contenido.getMetadatos()[3]);
				//TODO controlar que no hay inconsistencias entre el numero de columnas entre la tabla y los metadatos
		        //TODO ver que los datos introducidos mantienen la estructura. Si una columna es
	        	//eliminada hay que eliminar los datos relativos a ella
				
			} catch (NumberFormatException e1) {
				e1.printStackTrace();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
        }
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
    public static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("Seleccion de Archivos");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Add content to the window.
        frame.add(new Explorador());

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }
    
    

    public static void main(String[] args) {
        //Schedule a job for the event dispatch thread:
        //creating and showing this application's GUI.
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                //Turn off metal's use of bold fonts
                UIManager.put("swing.boldMetal", Boolean.FALSE); 
                createAndShowGUI();
            }
        });
    }


}
